using System;
using System.IO;
using System.Collections;

namespace Dnumber
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			StreamReader reader = new StreamReader("numbergame.in");
			int no_data = 0;
			while (true) {
				no_data++;
				String[] datas = reader.ReadLine().Split(null);
				int n = int.Parse(datas[0]);
				if (n == 0)
					break;

				ArrayList list = new ArrayList();
				int i;
				for (i = 1; i <= n; i++)
					list.Add(int.Parse(datas[i]));
				
				int max = 0;
				IEnumerator e = list.GetEnumerator();
				while (e.MoveNext()) {
					if ((int)e.Current > max)
						max = (int)e.Current;
				}
				bool[] flag = new bool[max + 1];
				for (i = 0; i < max; i++)
					flag[i] = false;
				e.Reset();
				while (e.MoveNext())
					flag[(int)e.Current] = true;

				ArrayList ret = new ArrayList();
				e.Reset();
				while (e.MoveNext()) {
					if (TryMe((bool[])flag.Clone(), (int)e.Current))
						ret.Add((int)e.Current);
				}
				
				System.Console.WriteLine("Test Case #" + no_data);
				if (ret.Count > 0) {
					System.Console.Write("The winning moves are:");
					e = ret.GetEnumerator();
					while (e.MoveNext())
						System.Console.Write(" " + (int)e.Current);
				} else {
					System.Console.Write("There's no winning move.");
				}
				System.Console.WriteLine("\n");
			}
		}
		static void ConstProp(bool[] flag, int num) {
			System.Console.Error.WriteLine(num);
			int i;
			for (i = num; i < flag.Length; i += num)
				flag[i] = false;
			for (i = 2; i < flag.Length; i++) {
				if (flag[i] == false && i + num < flag.Length)
					flag[i + num] = false;
				System.Console.Error.Write(i + ":" + flag[i] + " ");
			}
			System.Console.Error.WriteLine("");
		}
		static ArrayList winCaseForMe = new ArrayList();
		static ArrayList loseCaseForMe = new ArrayList();
		static ArrayList winCaseForOther = new ArrayList();
		static ArrayList loseCaseForOther = new ArrayList();

		static bool Search(ArrayList list, bool[] flag) {
			IEnumerator e = list.GetEnumerator();
			while (e.MoveNext()) {
				int i;
				bool ret = true;
				bool[] flagInList = (bool[])e.Current;
				for (i = 2; i < flag.Length; i++) {
					if (i >= flagInList.Length) {
						for (; i < flag.Length; i++) {
							if (flag[i] == true) {
								ret = false;
								i = flag.Length;
								break;
							}
						}
					} else {
						if (flag[i] != flagInList[i]) {
							ret = false;
							i = flag.Length;
							break;
						}
					}
				}
				if (ret) {
					for (; i < flagInList.Length; i++) {
						if (flagInList[i] == true) {
							ret = false;
							break;
						}
					}
					if (ret)
						return true;
				}
			}
			return false;
		}
		static bool TryMe(bool[] flag, int num) {
			ConstProp(flag, num);
			if (Search(winCaseForMe, flag))
				return true;
			else if (Search(loseCaseForMe, flag))
				return false;

			int i;
			for (i = 2; i < flag.Length; i++) {
				if (flag[i]) {
					if (!TestOther((bool[])flag.Clone(), i)) {
						loseCaseForMe.Add(flag);
						return false;
					}
				}
			}
			winCaseForMe.Add(flag);
			return true;
		}
		static bool TestOther(bool[] flag, int num) {
			ConstProp(flag, num);
			if (Search(winCaseForOther, flag))
				return false;
			else if (Search(loseCaseForOther, flag))
				return true;

			int i;
			for (i = 2; i < flag.Length; i++) {
				if (flag[i]) {
					if (TryMe((bool[])flag.Clone(), i)) {
						loseCaseForOther.Add(flag);
						return true;
					}
				}
			}
			winCaseForOther.Add(flag);
			return false;
		}
	}
}
