using System;
using System.Collections;
using System.IO;

namespace Hsmithnumber
{
	class Class1
	{
		static int[] prims = new int[]{2};
		static int max = 2;
		public static void CalcPrims(int num) {
			if (num > max) {
				bool [] flag = new bool[num + 1];
				ArrayList tmpPrims = new ArrayList();
				int i, j;
				for (i = 2; i <= num; i++) {
					flag[i] = true;
				}
				for (i = 2; i <= Math.Sqrt(num); i++) {
					if (flag[i]) {
						tmpPrims.Add(i);
						for (j = 2 * i; j <= num; j += i) {
							flag[j] = false;
						}
					}
				}
				for (; i <= num; i++) {
					if (flag[i])
						tmpPrims.Add(i);
				}
				prims = new int[tmpPrims.Count];
				tmpPrims.CopyTo(prims);
				max = num;
			}
		}
		static int CalcSum(int num) {
			int ret = 0;
			while (num > 0) {
				ret += num % 10;
				num = num / 10;
			}
			return ret;
		}
		[STAThread]
		static void Main(string[] args)
		{
			StreamReader reader = new StreamReader("smith.in");
			while (true) {
				int num = int.Parse(reader.ReadLine());
				if (num == 0)
					break;
				while (true) {
					bool flag = false;
					num++;
					int sum = CalcSum(num), sum2 = 0;
					System.Console.Error.WriteLine("sum of " + num + " is " + sum);
					CalcPrims((int)Math.Sqrt(num));
					int i, t = num;
					for (i = 0; !flag && i < prims.Length; i++) {
						while (!flag && t % prims[i] == 0) {
							if (num == prims[i]) {
								flag = true;
								break;
							}
							System.Console.Error.Write(prims[i] + "*");
							sum2 += CalcSum(prims[i]);
							t = t / prims[i];
						}
					}
					if (!flag && sum2 > 0) {
						if (t > 1) {
							System.Console.Error.Write(t.ToString());
							sum2 += CalcSum(t);
						}
						System.Console.Error.WriteLine("");
						if (sum == sum2) {
							System.Console.WriteLine(num.ToString());
							break;
						}
					} else {
						System.Console.Error.WriteLine("This is Primitive");
					}
				}
			}
		}
	}
}
